<?php
/*
$Id: configuration_cache_write.php, v1.02 2015-04-01 $

osCommerce, Open Source E-Commerce Solutions
http://www.oscommerce.com

Copyright (c) 2003 osCommerce

Released under the GNU General Public License
*/
function write_configuration_cache_file() {
  $cache_dir = rtrim(DIR_FS_PHPCACHE, '/');
  if (!is_dir($cache_dir)) {
    if (!mkdir($cache_dir, 0755)) return false;
  }
  if (!is_writable($cache_dir)) return false;
  $cache_file = DIR_FS_PHPCACHE . FILENAME_CONFIG_CACHE;
  $cache_output = "<?php\n";
  $configuration_query = tep_db_query('select configuration_key, configuration_value from ' . TABLE_CONFIGURATION . ' group by configuration_key order by configuration_key');
  while ($configuration = tep_db_fetch_array($configuration_query)) {
	  $cache_output .= "define('" . $configuration['configuration_key'] . "', '" . str_replace(array("\\", "'"), array("\\\\", "\\'"), $configuration['configuration_value']) . "');\n";
  }
  $cache_output .= "return 'Configuration Cache Success';\n";
  $cache_output .= "?>\n";
  if (file_exists($cache_file))
    @unlink($cache_file);
  $fp = fopen($cache_file, 'w');
  if ($fp === false) return false;
  $fout = fwrite($fp, $cache_output);
  fclose($fp);
  return ($fout == strlen($cache_output));
}
?>